#include <16F873A.h>
#device *=16, ADC=10
#fuses  HS, NOWDT, NOPROTECT, NOPUT, NOBROWNOUT, NOLVP, NOWRT
#use delay(clock=20000000)
#use rs232(baud=4800, XMIT=PIN_C6,RCV=PIN_C7, BITS=8, PARITY=N,STREAM=COM_A)
#use rs232(baud=57600, XMIT=PIN_B1,RCV=PIN_B0, BITS=8, PARITY=N,STREAM=COM_B)
#use fast_io(A)
#use fast_io(B)
#use fast_io(C)
#define C2ms    0xD8F0
#define C5ms    0x9E57

int8  rbuf;  // UART gps
int8  sbuf;  // UART analog
int8  tbuf;  // UART analog
int16 d;     // A/D data
int8  istr;  // 0: No Operation, 1: Send Only GPS data, 2: Send GPS and Sensor data
int8  flag;
int8  a;

#int_rda
void receive_byte(void)
{   rbuf=fgetc(COM_A); 
    if (istr!=0)
    {   fputc(rbuf,COM_B); 
    }
}

#int_timer1
void timer1_event(void)
{   set_timer1(C5ms);
    if(istr == 2)
    {  set_adc_channel(flag);
       delay_us(50);
       d=read_adc();
       sbuf = 0x80 | (make8(d,0) & 0x7f);
       d = d << 1;
       tbuf = 0x80 | (flag << 3) | make8(d,1);
       fputc(sbuf,COM_B); fputc(tbuf,COM_B);
       flag++;
       if ( flag==4 ) flag=0;
    }
}

void main()
{  port_b_pullups(FALSE);                    // No Pullup
   output_c(0x90); set_tris_C(0b10010000);   // Port_C RC5=RC7=RxD
   output_b(0x02); set_tris_B(0b00000101);   // Port_B RxD,TxD
   output_a(0x00); set_tris_A(0b11111111);   // Port_A All input
   setup_timer_1(T1_INTERNAL | T1_DIV_BY_1);
   set_timer1(C5ms);

   setup_adc( ADC_CLOCK_DIV_32 );   /* 1.6usec @ 20MHz  */
   setup_adc_ports( ALL_ANALOG );   /* use AN0-AN4 as ADC */
   set_adc_channel(0);              /* Select AN0 */
   delay_us(50);

   istr = 0; flag = 0;

   enable_interrupts(INT_TIMER1); // timer1
   enable_interrupts(INT_RDA);    // rx
   enable_interrupts(GLOBAL);     // int

Lp1:
   istr = 0; flag = 0;
   istr=fgetc(COM_B);
   if ( (istr==1) || (istr==2) )
   {  while(TRUE)
      {  a=input_b(); if (bit_test(a,2) != 1) break;
      }
      while(TRUE)
      {  a=input_b(); if (bit_test(a,2) == 1) break;
      }
   }
   goto Lp1;
}
